function Collage(canvasId) {
    var NONE = 0, MOVING = 1, SCALING = 2, ROTATING = 3;
    
    var mouseDown = false;
    var mousePrevX = 0;
    var mousePrevY = 0;
    var scle = 1;
    var selectedLayer = null;
    var layerState = NONE;
    var curr_img=''; //this.IMGARRY[curr_img]
    var backgroundColor = null;
    var backgroundImage = null;
    
    var canvasOffsetX = 0;
    var canvasOffsetY = 0;
    
    var scaleImg = new Image();
    var rotateImg = new Image();
    scaleImg.src = "resize.png";
    rotateImg.src = "rotate.png";
    
    var canvas = $(canvasId)[0];
    
    canvasOffsetX = $(canvasId).offset().left;
    canvasOffsetY = $(canvasId).offset().top;
    
    var context = canvas.getContext('2d');
    var layers = new Array();
        var ArrLayers = new Array();
   
    var touchable = 'createTouch' in document;
   if(touchable) {
    canvas.addEventListener( 'touchstart', mouseDownEvent, false );
    canvas.addEventListener( 'touchmove', mouseDrag, false );
    canvas.addEventListener( 'touchend', mouseOutEvent, false );
   }  
    //canvas.addEventListener('mousemove', mouseMoveEvent, false);
    canvas.addEventListener('mouseout', mouseOutEvent, false);
    canvas.addEventListener('mouseup', mouseOutEvent, false);
    canvas.addEventListener('mouseleave', mouseOutEvent, false);
    canvas.addEventListener('mousedown', mouseDownEvent, false);
    canvas.addEventListener('mousemove', mouseDrag, false);
    this.addLayer = function(img,imgar,currelev) {
        var layer = new Layer(img,imgar,currelev);
        layers.push(layer);

        redrawCanvas();
        return layer;
    }
    this.addLevelLayer =function(lyrId){
        ArrLayers[lyrId]= layers;
        layers = new Array();
    }
       
    this.slectLayerBunch = function(lyrId){
        layers = ArrLayers[lyrId];
        redrawCanvas();

    }
        
    this.redraw = function() {
        redrawCanvas();
    }
    this.getCanvas = function() {
        return canvas;
    }
    this.setBackgroundImage = function(img) {
        backgroundImage = img;
        redrawCanvas();
    }
    this.setBackgroundColor = function(color) {
        backgroundColor = color;
        redrawCanvas();
    }
        
    this.getArrLayers = function() {
            ArrLayers = ArrLayers;
        return ArrLayers;
    };
        
    this.getLayers = function() {
        return layers;
    }
    this.getLayer = function(i) {
        return layers[i];
    }
        
        this.get_Layer = function(_name,currntElev) {
            var obj;
            for(var i=0; i< layers.length; i++){

                if(layers[i].getName() == _name){
                    if((layers[i].getElev() == currntElev || layers[i].getElev() == '')){

                        obj = layers[i];
                    }
                }
            }
            return obj;
        }
        
    this.moveLayerUp = function(i) {
        i = parseInt(i);
        if (i < layers.length - 1) {
            var swapLayer = layers[1 + i];
            layers[1 + i] = layers[i];
            layers[i] = swapLayer;
            redrawCanvas();
            return true;
        } else {
            return false;
        }
    }
    this.moveLayerDown = function(i) {
        i = parseInt(i);
        if (i > 0) {
            var swapLayer = layers[i - 1];
            layers[i - 1] = layers[i];
            layers[i] = swapLayer;
            redrawCanvas();
            return true;
        } else {
            return false;
        }
    }
    this.removeLayer = function(i) {
        i = parseInt(i);
        if (i >= 0 && i < layers.length) {
            layers.splice(i,1);
            redrawCanvas();
        }
    }
    
function redrawCanvas() {
    for (i in layers) {

        if (layers[i].isVisible()) {
            context.save();
           context.drawImage(layers[i].getCanvas(), (canvas.width / 2) - (layers[i].width / 2), (canvas.height/2) - (layers[i].height / 2),layers[i].width,layers[i].height);
            context.restore();

        }
    }
}
        

  
    
    function mouseOutEvent(e) {
        mouseDown = false;
        layerState = NONE;
    }
    
    function mouseDownEvent(e) {
        mouseDown = true;
        //var obj =document.getElementById('vl');
        
        mousePrevX = e.pageX - canvasOffsetX;
        mousePrevY = e.pageY - canvasOffsetY;
        //obj.innerHTML =mousePrevX
    }
    function mouseDrag(e) {
        if ( mouseDown) {
         context.clearRect(0, 0, canvas.width, canvas.height);
        for(var i=0; i< layers.length; i++){
           layers[i].offsetX += e.pageX - canvasOffsetX - mousePrevX;
           layers[i].offsetY += e.pageY - canvasOffsetY - mousePrevY;
           layers[i].MoveObj( );
        }
        redrawCanvas();
        mousePrevX = e.pageX - canvasOffsetX;
        mousePrevY = e.pageY - canvasOffsetY;
        }
    }

    
    function isScalingArea(mX, mY, layer) {
        var scaleOffsetX = layer.offsetX + layer.width;
        var scaleOffsetY = layer.offsetY + layer.height;
        
        var square = new Square(
                new Vector(scaleOffsetX - scaleImg.width, scaleOffsetY - scaleImg.height),
                new Vector(scaleOffsetX, scaleOffsetY - scaleImg.height),
                new Vector(scaleOffsetX, scaleOffsetY),
                new Vector(scaleOffsetX - scaleImg.width, scaleOffsetY));

        square.rotate(layer.angle);
        square.alignBottomRight(layer.getSquare().c);
            
        return square.intersect(new Vector(mX, mY));
    }
    
    function isRotatingArea(mX, mY, layer) {
        var scaleOffsetX = layer.offsetX + layer.width;
        var scaleOffsetY = layer.offsetY + layer.height;
        
        var square = new Square(
                new Vector(scaleOffsetX - rotateImg.width, layer.offsetY),
                new Vector(scaleOffsetX, layer.offsetY),
                new Vector(scaleOffsetX, layer.offsetY + rotateImg.height),
                new Vector(scaleOffsetX - rotateImg.width, layer.offsetY + rotateImg.height));

        square.rotate(layer.angle);
        square.alignTopRight(layer.getSquare().b);
        return square.intersect(new Vector(mX, mY));
    }
}

function Layer(default_ImgId,OptArr,Curr_elev) {
        //curr_img = img;

    this.currelev = Curr_elev;
    this.defaultImgId = default_ImgId;
    this.offsetX = 0;
    this.offsetY = 0;
    this.scle = 2.5;
        //this.IMGARRY = new Array();
    this.IMGARRY = OptArr;
    this.imgObj= this.IMGARRY[this.defaultImgId][this.currelev];
    
    if(this.imgObj.img.naturalWidth == 0){
        this.width = 2069;
        this.height = 1483;
        }else{
        this.width = this.imgObj.img.naturalWidth;
        this.height =this.imgObj.img.naturalHeight;
        }
    this.canvas = document.createElement('canvas');
    this.canvas.width = this.width;
    this.canvas.height = this.height;
    this.context = this.canvas.getContext('2d');
    this.context.save();
    this.context.translate(this.width / 2, this.height / 2);
    this.context.globalAlpha =1
    this.opacity = 1;
    this.visible = true;
    
    this.angle = 0;
    this.title = "";
    this.Alts = "";
    this.Dependaints ="";
    this.Name ="";
    this.Elevation ="";
    this.displayLayerOption = "";
    this.altOption ="";
        
    this.isVisible = function() {
        return this.visible;
    }
    this.toggleVisible = function() {
        this.visible = !this.visible;
    }
    

    this.getImage = function() {
        //return this.img;
                //return this.IMGARRY[this.currimg];
                return this.imgObj.img;
    }
    
    
    this.redraw = function() {
        var startX = this.width / 2 - this.width;
        var startY = this.height / 2 - this.height;
        var ctx = this.context;
        var wid = this.width
        var hit = this.height
        ctx.clearRect(startX, startY, this.canvas.width, this.canvas.height);
        
        var img_Obj = this.imgObj.img;
        if(img_Obj != undefined){
        ctx.drawImage(img_Obj, startX, startY,wid,hit);
        }
    }
        
        
    this.getCanvas = function() {
        this.redraw();
        return this.canvas;
    }
    
 
    //this.scale = function(width, height) {
    this.scale = function(valW,valH) {
        this.context.restore();
        
        //this.width = 2069 * val;
        //this.height = 1483 * val;
        this.width =  valW;
        this.height =  valH;
                
        this.canvas.width = this.width;
        this.canvas.height = this.height;
        // this.context.clearRect(0, 0, this.canvas.width, this.canvas.height);
        this.context.translate(this.width / 2, this.height / 2);
        
        this.redraw();
    }
    
    this.MoveObj = function() {
        this.context.save();
        this.canvas.width = this.width;
        this.canvas.height = this.height;
        this.context.clearRect(0, 0, this.canvas.width, this.canvas.height);
        this.context.translate(this.offsetX + (this.width / 2) , this.offsetY +(this.height / 2));
        this.context.restore();
    }
        
    this.setAngle = function(angle) {
        this.angle = angle;
    }
    this.getAngle = function() {
        return this.angle;
    }
        //-----------------------------------
    //this.setIMG = function(id,imgObj) {
    //    this.IMGARRY[id] = imgObj;
    //}
        
    //this.getIMG = function(id) {
    //    return this.IMGARRY[id];
   // }
    //this.setCurrImg = function(id) {
    //    this.currimg =id;
    //}
        
    //this.getCurrImg = function() {
    //    return this.currimg;
    //}
        //-----------------------------------
    this.setTitle = function(title) {
        this.title = title;
    }
    this.getTitle = function() {
        return this.title;
    }
        
     /*   this.getAlt = function() {
        return this.Alts;
    }
     this.setAlt = function(Alts){
             this.Alts = Alts;
        }*/
        
        this.getDependaints = function() {
                return this.Dependaints;
    }
       
        this.setDependaints = function(Dependaints){
             this.Dependaints = Dependaints;
        }
        
        this.setName = function(Name){
             this.Name = Name;
        }
        this.getName = function() {
                return this.Name;
    }
        this.setdisp = function(opt){
             this.displayLayerOption = opt;
        }
        this.getdisp = function() {
                return this.displayLayerOption;
    }
        
    /* this.setALter = function(opt){
             this.altOption = opt;
        }
        this.getALter = function() {
                return this.altOption;
    }*/
        
    this.getExclusiv = function() {  
        return this.Alts;
    }
    
     this.setExclusiv = function(Alts){
             this.Alts = Alts;
        }
  
        
         //this.setElev = function(Elevation){
             //this.Elevation = Elevation;
       // }
        
        //this.getElev = function(Elevation){
               // return this.Elevation;
    //}
}

